/* file: 5000tact.c 
 * door: Arnold Metselaar
 * 
 * programma voor het 5000-spel (zie MCCM 83)
 * beslissende functies voor automatisch spelen
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "5000spel.h"

/* in deze file : */
FAST doorgaan(char*,char*,char*,UFAST,UFAST,UFAST);
char extra_gok(char);
uint ber_sc(char*, char*, UFAST, UFAST, UFAST, uint);

extern uint RestB[WINLIM];
extern void update(UFAST, char *, FAST, FAST, FAST); 

  /* bepaal welke stenen uitgelegd  moeten  worden  en  of  daarna  nog
gegooid moet worden */
FAST doorgaan(char * bak, char * worp, char * zet_uit, 
	      UFAST totsc, UFAST brtsc, UFAST vb)
{
  UFAST i, lenw, old;
  FAST wrdb, wrdn;
  uint bstsc, nwsc;
  FAST vl, uitw;
  char buf[7];
  register char * nuit;
                      
  nuit = buf;
  zet_uit[0] = '\0';
  if (totsc < WINLIM-SCHRLIM)
    uitw=WINLIM-totsc-brtsc;
  else 
    uitw=SCHRLIM-brtsc;
  /* uitw is genoeg om te winnen, mits deze worp nog nodig was. */
  vl=3; lenw = strlen(worp);
  old = 0;
  for (i=(1<<lenw)-1 ; i && vl ; i--)
  {
    if (sub_str_test(worp,nuit,i) && ((wrdn=waarde(nuit,bak)) >=0))
    {
      if (wrdn>=uitw) 
	/* if (wrdn>0) */ vl=0;
      switch(vl)
      {
	case 3: wrdb=wrdn;
		strcpy(zet_uit,nuit);
		update(6-lenw, worp, i, old, wrdn);
		old = i;
		vl=2;
		break;
        case 2:	bstsc=ber_sc(bak,zet_uit,totsc,brtsc+wrdb,vb,0);
#ifdef DEMO
		if (klepnivo>=3) 
		  printf("\n+ %s = %d -> %u\n",zet_uit,SC*wrdb,bstsc);
#endif
		vl=1;
	case 1:	nwsc=ber_sc(bak,nuit,totsc,brtsc+wrdn,vb,bstsc);
#ifdef DEMO
		if (klepnivo>=3) printf("+ %s = %d -> %u\n",nuit,SC*wrdn,nwsc);
#endif
                if (bstsc<=nwsc) break;
		bstsc=nwsc; 
		wrdb=wrdn; 
	case 0: strcpy(zet_uit,nuit);
		update(6-lenw, worp, i, old, wrdn);
		old = i;
      }
    }
  }

  if ((vl==3)||(vl==0)) return old; /* mislukt of gewonnen */
  if ((brtsc+wrdb<SCHRLIM)||(wrdb==0)     /* te weinig of sextet nodig of */
      || ((strlen(zet_uit)==lenw)&&(vb<BAKLIM-1))) /* volle bak bewijzen */
    return 0x80 | old;

  if (vl==2) bstsc=ber_sc(bak,zet_uit,totsc,brtsc+wrdb,vb,0);
  return (bstsc<RestB[totsc+brtsc+wrdb])? 0x80 | old : old;
}

  /* bepaal de extra gok */
char extra_gok (char x)
{ 
  return '3'+(x&1) ;
}

/* Zet substring met mask index in *deel, 
   Als er een kleinere index die, modulo permutaties, dezelfde deelstring 
   geeft, is, dan geeft deze functie de waarde nul en is de deelstring 
   mogelijk niet compleet. */ 

FAST sub_str_test(char *geheel, char *deel,FAST index) 
{ 
  FAST j; 
  char *z; 
  char skipped[7];

  z=skipped;
  *z='\0';
  for ( j=1 ; j && (j<=index) ; j<<=1, geheel++)
  {
    if (j&index)
    { 
      *deel++=*geheel; 
      if (strchr(skipped,*geheel)) j=0; 
    }
    else 
    { 
      *z++=*geheel;
      *z='\0';
    }
  }
  *deel='\0';
  return j;
}

/* zet substring met code index in *deel. */
void sub_str(char *geheel, char *deel, FAST index)
{
  int j;
  FAST res;

  for ( j=res=1 ; j<=index ; j<<=1, geheel++)
  {
    if (j&index)
    { 
      *deel++=*geheel; 
    }
  }
  *deel='\0';
}

/* bereken de score van een uitzetsel */
uint ber_sc(char *bak, char *uit,UFAST totsc,UFAST brtsc,UFAST vb, uint max)
{
  char n_bak[7];

  return verw_beurt(strcat(strcpy(n_bak,bak),uit), 
		    (totsc>(WINLIM-SCHRLIM)) ? WINLIM-SCHRLIM : totsc,
		    brtsc, vb, max);
}

