/* file: 5000util.c 
 * door: Arnold Metselaar
 * 
 * programma voor het 5000-spel (zie MCCM 83)
 * waarde van een worp, enkele algemene functies 
 */

#include <string.h>
#include <stdlib.h>

#include "5000spel.h"

/* in deze file :*/
void *xalloc(size_t);
FAST deel_van(char*, char*);
FAST waarde(char*, char*);


/* komen alle karakters van *s1 minstens zo vaak voor in *s2 ? */
FAST deel_van(char *s1, char *s2)
{
  char *p,*q, *z;
  char buf[7];

  strcpy(buf,s2);
  q=buf+strlen(buf);
  for (p=s1 ; *p ; p++)
  {
    if ( (z=strchr(buf,*p)) ) 
      { 
	*z=*--q;
	*q='\0';
      }
    else return 0;
  }
  return 1;
}

/* hoeveel is *worp waard als *bak al uitligt */ 
FAST waarde(char *worp, char *bak)
{
  FAST i,t;
  char c,*p;
  char xxyyzz[7];
  
  if (strlen(worp)==0) return -1;
  c=worp[0]; t=0;
  for (p=worp ; *p ; p++) t+=((*p==c)?1:-7); 
  for (p=bak  ; *p ; p++) t+=((*p==c)?1:-7);
  if (t==6) return WINLIM; /* sextet */

  if ((t>3)&&(c!='1')&&(c!='5')) return 0;  /* moet door met sextet */
  c=bak[0];
  if ((c!='1')&&(c!='5'))
  {
    for (p=bak,t=0 ; *p ; p++) if (*p==c) t++;
    if (t>3) return -1; /* moest door met sextet */
  }
  
  if (strlen(worp)==6)
  {
    for (t=i=0, p=xxyyzz ; i<6 ; i++)
    { 
      if (strchr(worp,worp[i])==worp+i)
        if (t++<3) { *p++=worp[i]; *p++=worp[i]; }
    }
    if (t==6) return W_STRAAT;
    *p='\0';
    if ( (t==3) && deel_van(xxyyzz,worp) ) return W_3_PAAR;
  }

  for (i=0; i<6; ) xxyyzz[i++]=0;
  for (p=worp; *p; ) xxyyzz[*(p++)-'1']++;
  for (t=i=0; (i<6)&&(t>=0); i++)
  {
    if (xxyyzz[i]>=3)
      { t+= i?(i+1)*W_PIK:W_3_PIK; xxyyzz[i]-=3; }
    if (xxyyzz[i]) t= ((i%4)?-1:t+xxyyzz[i]* (i?W_VIJF:W_PIK));
  }
  return t;      
}


